<?php

declare(strict_types=1);

namespace WDB\GuzzleTest\Middleware\Guzzle;

use TYPO3\CMS\Core\Http\ServerRequest;
use TYPO3\CMS\Core\Http\ServerRequestFactory;
use TYPO3\CMS\Extbase\Utility\DebuggerUtility;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class FormHandler
{
    /** @var ServerRequestInterface */
    private $serverRequest;

    /** @var ServerRequestFactoryInterface */
    private $serverRequestFactory;

    private $myIp = '180.251.135.65';
    
    private $doDebug = false;

    /**
     * Initiate the Request Factory, which allows to run multiple requests (prefer dependency injection)
     * HINT: dependency injection doen't work
     */
    public function __construct()
    {
        $this->initServerRequest();
    }

    protected function initServerRequest() : void
    {
        $this->serverRequestFactory = GeneralUtility::makeInstance(ServerRequestFactory::class);

        /* @internal : Note that the called method is not public API yet. [v10, v11] */
        $this->serverRequest = $this->serverRequestFactory::fromGlobals();
    }
    
    public function doDebug() : bool
    {
        return (bool) ($this->doDebug && ($_SERVER['REMOTE_ADDR'] == $this->myIp || $_SERVER['HTTP_X_FORWARDED_FOR'] == $this->myIp));
    }

    /**
     * Is redirecting pages after form-submits for selected forms
     * if according configuration is existing.
     */
    public function handler() : void
    {
    }
}
